package io.gitlab.jfronny.combit;

import io.gitlab.jfronny.libjf.config.api.ConfigHolder;
import io.gitlab.jfronny.libjf.unsafe.UltraEarlyInit;
import net.minecraft.entity.damage.DamageSource;

import java.util.HashSet;

public class CombitConfigValidator implements UltraEarlyInit {
    @Override
    public void init() {
        boolean changed = false;
        if (CombitConfig.attackerWhitelist == null) {
            changed = true;
            CombitConfig.attackerWhitelist = new HashSet<>();
            CombitConfig.attackerWhitelist.add("minecraft:slime");
            CombitConfig.attackerWhitelist.add("tconstruct:blueslime");
            CombitConfig.attackerWhitelist.add("thaumcraft:thaumslime");
        }
        if (CombitConfig.targetEntityWhitelist == null) {
            changed = true;
            CombitConfig.targetEntityWhitelist = new HashSet<>();
        }
        if (CombitConfig.damageSourceWhitelist == null) {
            changed = true;
            CombitConfig.damageSourceWhitelist = new HashSet<>();
            CombitConfig.damageSourceWhitelist.add(DamageSource.IN_FIRE.getName());
            CombitConfig.damageSourceWhitelist.add(DamageSource.LIGHTNING_BOLT.getName());
            CombitConfig.damageSourceWhitelist.add(DamageSource.LAVA.getName());
            CombitConfig.damageSourceWhitelist.add(DamageSource.HOT_FLOOR.getName());
            CombitConfig.damageSourceWhitelist.add(DamageSource.IN_WALL.getName());
            CombitConfig.damageSourceWhitelist.add(DamageSource.CACTUS.getName());
            CombitConfig.damageSourceWhitelist.add(DamageSource.OUT_OF_WORLD.getName());
            CombitConfig.damageSourceWhitelist.add(DamageSource.SWEET_BERRY_BUSH.getName());
        }
        if (CombitConfig.entityHealthBlacklist == null) {
            changed = true;
            CombitConfig.entityHealthBlacklist = new HashSet<>();
            CombitConfig.entityHealthBlacklist.add("minecraft:player");
        }
        if (changed) {
            ConfigHolder.getInstance().getRegistered().get("combit").write();
        }
    }
}
